diff --git a/gcc/config/mips/mips.c b/gcc/config/mips/mips.c
index 143169b..d50fc16 100644
--- a/gcc/config/mips/mips.c
+++ b/gcc/config/mips/mips.c
@@ -17185,7 +17185,7 @@ mips_option_override (void)
 
   /* Pre-IEEE 754-2008 MIPS hardware has a quirky almost-IEEE format
      for all its floating point.  */
-  if (mips_nan != MIPS_IEEE_754_2008)
+  if (GCC_OPTION (mips_nan) != MIPS_IEEE_754_2008)
     {
       REAL_MODE_FORMAT (SFmode) = &mips_single_format;
       REAL_MODE_FORMAT (DFmode) = &mips_double_format;
@@ -17194,24 +17194,24 @@ mips_option_override (void)
 
   /* Make sure that the user didn't turn off paired single support when
      MIPS-3D support is requested.  */
-  if (TARGET_MIPS3D
+  if (GCC_OPTION (TARGET_MIPS3D)
       && (target_flags_explicit & MASK_PAIRED_SINGLE_FLOAT)
       && !TARGET_PAIRED_SINGLE_FLOAT)
     error ("%<-mips3d%> requires %<-mpaired-single%>");
 
   /* If TARGET_MIPS3D, enable MASK_PAIRED_SINGLE_FLOAT.  */
-  if (TARGET_MIPS3D)
-    target_flags |= MASK_PAIRED_SINGLE_FLOAT;
+  if (GCC_OPTION (TARGET_MIPS3D))
+    GCC_OPTION (target_flags) |= MASK_PAIRED_SINGLE_FLOAT;
 
   /* Make sure that when TARGET_PAIRED_SINGLE_FLOAT is true, TARGET_FLOAT64
      and TARGET_HARD_FLOAT_ABI are both true.  */
   if (TARGET_PAIRED_SINGLE_FLOAT && !(TARGET_FLOAT64 && TARGET_HARD_FLOAT_ABI))
     {
       error ("%qs must be used with %qs",
-	     TARGET_MIPS3D ? "-mips3d" : "-mpaired-single",
+	     GCC_OPTION (TARGET_MIPS3D) ? "-mips3d" : "-mpaired-single",
 	     TARGET_HARD_FLOAT_ABI ? "-mfp64" : "-mhard-float");
-      target_flags &= ~MASK_PAIRED_SINGLE_FLOAT;
-      TARGET_MIPS3D = 0;
+      GCC_OPTION (target_flags) &= ~MASK_PAIRED_SINGLE_FLOAT;
+      GCC_OPTION (TARGET_MIPS3D) = 0;
     }
 
   /* Make sure that -mpaired-single is only used on ISAs that support it.
@@ -17221,21 +17221,21 @@ mips_option_override (void)
     {
       error ("the %qs architecture does not support paired-single"
 	     " instructions", mips_arch_info->name);
-      target_flags &= ~MASK_PAIRED_SINGLE_FLOAT;
-      TARGET_MIPS3D = 0;
+      GCC_OPTION (target_flags) &= ~MASK_PAIRED_SINGLE_FLOAT;
+      GCC_OPTION (TARGET_MIPS3D) = 0;
     }
 
-  if (mips_r10k_cache_barrier != R10K_CACHE_BARRIER_NONE
+  if (GCC_OPTION (mips_r10k_cache_barrier) != R10K_CACHE_BARRIER_NONE
       && !TARGET_CACHE_BUILTIN)
     {
       error ("%qs requires a target that provides the %qs instruction",
 	     "-mr10k-cache-barrier", "cache");
-      mips_r10k_cache_barrier = R10K_CACHE_BARRIER_NONE;
+      GCC_OPTION (mips_r10k_cache_barrier) = R10K_CACHE_BARRIER_NONE;
     }
 
   /* If TARGET_DSPR2, enable TARGET_DSP.  */
-  if (TARGET_DSPR2)
-    TARGET_DSP = true;
+  if (GCC_OPTION (TARGET_DSPR2))
+    GCC_OPTION (TARGET_DSP) = true;
 
   /* .eh_frame addresses should be the same width as a C pointer.
      Most MIPS ABIs support only one pointer size, so the assembler
@@ -17255,13 +17255,13 @@ mips_option_override (void)
      default behavior, it seems unwise to rely on future versions
      of gas behaving the same way.  We therefore avoid using .cfi
      directives for -mlong32 as well.  */
-  if (mips_abi == ABI_EABI && TARGET_64BIT)
-    flag_dwarf2_cfi_asm = 0;
+  if (GCC_OPTION (mips_abi) == ABI_EABI && TARGET_64BIT)
+    GCC_OPTION (flag_dwarf2_cfi_asm) = 0;
 
   /* .cfi_* directives generate a read-only section, so fall back on
      manual .eh_frame creation if we need the section to be writable.  */
   if (TARGET_WRITABLE_EH_FRAME)
-    flag_dwarf2_cfi_asm = 0;
+    GCC_OPTION (flag_dwarf2_cfi_asm) = 0;
 
   mips_init_print_operand_punct ();
 
@@ -17309,19 +17309,19 @@ mips_option_override (void)
      was selected explicitly.  */
   if ((target_flags_explicit & MASK_FIX_R4000) == 0
       && strcmp (mips_arch_info->name, "r4000") == 0)
-    target_flags |= MASK_FIX_R4000;
+    GCC_OPTION (target_flags) |= MASK_FIX_R4000;
 
   /* Default to working around R4400 errata only if the processor
      was selected explicitly.  */
   if ((target_flags_explicit & MASK_FIX_R4400) == 0
       && strcmp (mips_arch_info->name, "r4400") == 0)
-    target_flags |= MASK_FIX_R4400;
+    GCC_OPTION (target_flags) |= MASK_FIX_R4400;
 
   /* Default to working around R10000 errata only if the processor
      was selected explicitly.  */
   if ((target_flags_explicit & MASK_FIX_R10000) == 0
       && strcmp (mips_arch_info->name, "r10000") == 0)
-    target_flags |= MASK_FIX_R10000;
+    GCC_OPTION (target_flags) |= MASK_FIX_R10000;
 
   /* Make sure that branch-likely instructions available when using
      -mfix-r10000.  The instructions are not available if either:
@@ -17339,21 +17339,21 @@ mips_option_override (void)
     {
       warning (0, "the %qs architecture does not support the synci "
 	       "instruction", mips_arch_info->name);
-      target_flags &= ~MASK_SYNCI;
+      GCC_OPTION (target_flags) &= ~MASK_SYNCI;
     }
 
   /* Only optimize PIC indirect calls if they are actually required.  */
   if (!TARGET_USE_GOT || !TARGET_EXPLICIT_RELOCS)
-    target_flags &= ~MASK_RELAX_PIC_CALLS;
+    GCC_OPTION (target_flags) &= ~MASK_RELAX_PIC_CALLS;
 
   /* Save base state of options.  */
-  mips_base_target_flags = target_flags;
-  mips_base_schedule_insns = flag_schedule_insns;
-  mips_base_reorder_blocks_and_partition = flag_reorder_blocks_and_partition;
-  mips_base_move_loop_invariants = flag_move_loop_invariants;
-  mips_base_align_loops = align_loops;
-  mips_base_align_jumps = align_jumps;
-  mips_base_align_functions = align_functions;
+  mips_base_target_flags = GCC_OPTION (target_flags);
+  mips_base_schedule_insns = GCC_OPTION (flag_schedule_insns);
+  mips_base_reorder_blocks_and_partition = GCC_OPTION (flag_reorder_blocks_and_partition);
+  mips_base_move_loop_invariants = GCC_OPTION (flag_move_loop_invariants);
+  mips_base_align_loops = GCC_OPTION (align_loops);
+  mips_base_align_jumps = GCC_OPTION (align_jumps);
+  mips_base_align_functions = GCC_OPTION (align_functions);
 
   /* Now select the ISA mode.
 
@@ -17456,7 +17456,7 @@ mips_conditional_register_usage (void)
       fixed_regs[26] = call_used_regs[26] = 1;
       fixed_regs[27] = call_used_regs[27] = 1;
       fixed_regs[30] = call_used_regs[30] = 1;
-      if (optimize_size)
+      if (GCC_OPTION (optimize_size))
 	{
 	  fixed_regs[8] = call_used_regs[8] = 1;
 	  fixed_regs[9] = call_used_regs[9] = 1;
@@ -17475,7 +17475,7 @@ mips_conditional_register_usage (void)
 			      reg_class_contents[(int) MD_REGS]);
     }
   /* $f20-$f23 are call-clobbered for n64.  */
-  if (mips_abi == ABI_64)
+  if (GCC_OPTION (mips_abi) == ABI_64)
     {
       int regno;
       for (regno = FP_REG_FIRST + 20; regno < FP_REG_FIRST + 24; regno++)
@@ -17483,7 +17483,7 @@ mips_conditional_register_usage (void)
     }
   /* Odd registers in the range $f21-$f31 (inclusive) are call-clobbered
      for n32.  */
-  if (mips_abi == ABI_N32)
+  if (GCC_OPTION (mips_abi) == ABI_N32)
     {
       int regno;
       for (regno = FP_REG_FIRST + 21; regno <= FP_REG_FIRST + 31; regno+=2)
@@ -18093,7 +18093,7 @@ void mips_function_profiler (FILE *file)
 {
   if (TARGET_MIPS16)
     sorry ("mips16 function profiling");
-  if (TARGET_LONG_CALLS)
+  if (GCC_OPTION (TARGET_LONG_CALLS))
     {
       /* For TARGET_LONG_CALLS use $3 for the address of _mcount.  */
       if (Pmode == DImode)
@@ -18108,7 +18108,7 @@ void mips_function_profiler (FILE *file)
   if (cfun->static_chain_decl != NULL)
     fprintf (file, "\tmove\t%s,%s\n", reg_names[2],
 	     reg_names[STATIC_CHAIN_REGNUM]);
-  if (TARGET_MCOUNT_RA_ADDRESS)
+  if (GCC_OPTION (TARGET_MCOUNT_RA_ADDRESS))
     {
       /* If TARGET_MCOUNT_RA_ADDRESS load $12 with the address of the
 	 ra save location.  */
@@ -18129,7 +18129,7 @@ void mips_function_profiler (FILE *file)
 	     reg_names[STACK_POINTER_REGNUM],
 	     Pmode == DImode ? 16 : 8);
 
-  if (TARGET_LONG_CALLS)
+  if (GCC_OPTION (TARGET_LONG_CALLS))
     fprintf (file, "\tjalr\t%s\n", reg_names[3]);
   else
     fprintf (file, "\tjal\t_mcount\n");
@@ -18849,7 +18849,7 @@ unsigned int
 mips_case_values_threshold (void)
 {
   /* In MIPS16 mode using a larger case threshold generates smaller code.  */
-  if (TARGET_MIPS16 && optimize_size)
+  if (TARGET_MIPS16 && GCC_OPTION (optimize_size))
     return 10;
   else
     return default_case_values_threshold ();
diff --git a/gcc/config/mips/mips.h b/gcc/config/mips/mips.h
index a786d4c..76d9ddd 100644
--- a/gcc/config/mips/mips.h
+++ b/gcc/config/mips/mips.h
@@ -90,12 +90,12 @@ struct mips_cpu_info {
 /* Run-time compilation parameters selecting different hardware subsets.  */
 
 /* True if we are generating position-independent VxWorks RTP code.  */
-#define TARGET_RTP_PIC (TARGET_VXWORKS_RTP && flag_pic)
+#define TARGET_RTP_PIC (TARGET_VXWORKS_RTP && GCC_OPTION (flag_pic))
 
 /* True if the output file is marked as ".abicalls; .option pic0"
    (-call_nonpic).  */
 #define TARGET_ABICALLS_PIC0 \
-  (TARGET_ABSOLUTE_ABICALLS && TARGET_PLT)
+  (TARGET_ABSOLUTE_ABICALLS && GCC_OPTION (TARGET_PLT))
 
 /* True if the output file is marked as ".abicalls; .option pic2" (-KPIC).  */
 #define TARGET_ABICALLS_PIC2 \
@@ -120,7 +120,7 @@ struct mips_cpu_info {
 
 #define TARGET_ABSOLUTE_ABICALLS	\
   (TARGET_ABICALLS			\
-   && !TARGET_SHARED			\
+   && !GCC_OPTION (TARGET_SHARED)			\
    && TARGET_EXPLICIT_RELOCS		\
    && !ABI_HAS_64BIT_SYMBOLS)
 
@@ -156,7 +156,7 @@ struct mips_cpu_info {
 
 /* True if we can use the J and JAL instructions.  */
 #define TARGET_ABSOLUTE_JUMPS \
-  (!flag_pic || TARGET_ABSOLUTE_ABICALLS)
+  (!GCC_OPTION (flag_pic) || TARGET_ABSOLUTE_ABICALLS)
 
 /* True if indirect calls must use register class PIC_FN_ADDR_REG.
    This is true for both the PIC and non-PIC VxWorks RTP modes.  */
@@ -171,7 +171,7 @@ struct mips_cpu_info {
 #ifdef HAVE_LD_PERSONALITY_RELAXATION
 #define TARGET_WRITABLE_EH_FRAME 0
 #else
-#define TARGET_WRITABLE_EH_FRAME (flag_pic && TARGET_SHARED)
+#define TARGET_WRITABLE_EH_FRAME (GCC_OPTION (flag_pic) && GCC_OPTION (TARGET_SHARED))
 #endif
 
 /* Test the assembler to set ISA_HAS_DSP_MULT to DSP Rev 1 or 2.  */
@@ -182,24 +182,24 @@ struct mips_cpu_info {
 #endif
 
 /* The ISA compression flags that are currently in effect.  */
-#define TARGET_COMPRESSION (target_flags & (MASK_MIPS16 | MASK_MICROMIPS))
+#define TARGET_COMPRESSION (GCC_OPTION (target_flags) & (MASK_MIPS16 | MASK_MICROMIPS))
 
 /* Generate mips16 code */
-#define TARGET_MIPS16		((target_flags & MASK_MIPS16) != 0)
+#define TARGET_MIPS16		((GCC_OPTION (target_flags) & MASK_MIPS16) != 0)
 /* Generate mips16e code. Default 16bit ASE for mips32* and mips64* */
 #define GENERATE_MIPS16E	(TARGET_MIPS16 && mips_isa >= 32)
 /* Generate mips16e register save/restore sequences.  */
-#define GENERATE_MIPS16E_SAVE_RESTORE (GENERATE_MIPS16E && mips_abi == ABI_32)
+#define GENERATE_MIPS16E_SAVE_RESTORE (GENERATE_MIPS16E && GCC_OPTION (mips_abi) == ABI_32)
 
 /* True if we're generating a form of MIPS16 code in which general
    text loads are allowed.  */
 #define TARGET_MIPS16_TEXT_LOADS \
-  (TARGET_MIPS16 && mips_code_readable == CODE_READABLE_YES)
+  (TARGET_MIPS16 && GCC_OPTION (mips_code_readable) == CODE_READABLE_YES)
 
 /* True if we're generating a form of MIPS16 code in which PC-relative
    loads are allowed.  */
 #define TARGET_MIPS16_PCREL_LOADS \
-  (TARGET_MIPS16 && mips_code_readable >= CODE_READABLE_PCREL)
+  (TARGET_MIPS16 && GCC_OPTION (mips_code_readable) >= CODE_READABLE_PCREL)
 
 /* Generic ISA defines.  */
 #define ISA_MIPS1		    (mips_isa == 1)
@@ -304,8 +304,8 @@ struct mips_cpu_info {
 				     || TUNE_MIPS4130		\
 				     || TUNE_24K)
 
-#define TARGET_OLDABI		    (mips_abi == ABI_32 || mips_abi == ABI_O64)
-#define TARGET_NEWABI		    (mips_abi == ABI_N32 || mips_abi == ABI_64)
+#define TARGET_OLDABI		    (GCC_OPTION (mips_abi) == ABI_32 || GCC_OPTION (mips_abi) == ABI_O64)
+#define TARGET_NEWABI		    (GCC_OPTION (mips_abi) == ABI_N32 || GCC_OPTION (mips_abi) == ABI_64)
 
 /* TARGET_HARD_FLOAT and TARGET_SOFT_FLOAT reflect whether the FPU is
    directly accessible, while the command-line options select
@@ -388,7 +388,7 @@ struct mips_cpu_info {
       if (mips_base_compression_flags & MASK_MIPS16)			\
 	builtin_define ("__mips16");					\
 									\
-      if (TARGET_MIPS3D)						\
+      if (GCC_OPTION (TARGET_MIPS3D))						\
 	builtin_define ("__mips3d");					\
 									\
       if (TARGET_SMARTMIPS)						\
@@ -397,16 +397,16 @@ struct mips_cpu_info {
       if (mips_base_compression_flags & MASK_MICROMIPS)			\
 	builtin_define ("__mips_micromips");				\
 									\
-      if (TARGET_MCU)							\
+      if (GCC_OPTION (TARGET_MCU))							\
 	builtin_define ("__mips_mcu");					\
 									\
-      if (TARGET_EVA)							\
+      if (GCC_OPTION (TARGET_EVA))							\
 	builtin_define ("__mips_eva");					\
 									\
-      if (TARGET_DSP)							\
+      if (GCC_OPTION (TARGET_DSP))							\
 	{								\
 	  builtin_define ("__mips_dsp");				\
-	  if (TARGET_DSPR2)						\
+	  if (GCC_OPTION (TARGET_DSPR2))						\
 	    {								\
 	      builtin_define ("__mips_dspr2");				\
 	      builtin_define ("__mips_dsp_rev=2");			\
@@ -463,7 +463,7 @@ struct mips_cpu_info {
 	  builtin_define ("_MIPS_ISA=_MIPS_ISA_MIPS64");		\
 	}								\
 									\
-      switch (mips_abi)							\
+      switch (GCC_OPTION (mips_abi))							\
 	{								\
 	case ABI_32:							\
 	  builtin_define ("_ABIO32=1");					\
@@ -494,7 +494,7 @@ struct mips_cpu_info {
 									\
       /* These defines reflect the ABI in use, not whether the  	\
 	 FPU is directly accessible.  */				\
-      if (TARGET_NO_FLOAT)						\
+      if (GCC_OPTION (TARGET_NO_FLOAT))						\
 	builtin_define ("__mips_no_float");				\
       else if (TARGET_HARD_FLOAT_ABI)					\
 	builtin_define ("__mips_hard_float");				\
@@ -507,10 +507,10 @@ struct mips_cpu_info {
       if (TARGET_PAIRED_SINGLE_FLOAT)					\
 	builtin_define ("__mips_paired_single_float");			\
 									\
-      if (mips_abs == MIPS_IEEE_754_2008)				\
+      if (GCC_OPTION (mips_abs) == MIPS_IEEE_754_2008)				\
 	builtin_define ("__mips_abs2008");				\
 									\
-      if (mips_nan == MIPS_IEEE_754_2008)				\
+      if (GCC_OPTION (mips_nan) == MIPS_IEEE_754_2008)				\
 	builtin_define ("__mips_nan2008");				\
 									\
       if (TARGET_BIG_ENDIAN)						\
@@ -566,7 +566,7 @@ struct mips_cpu_info {
 	  builtin_define ("_LANGUAGE_C");				\
 	}								\
 									\
-      if (mips_abi == ABI_EABI)						\
+      if (GCC_OPTION (mips_abi) == ABI_EABI)						\
 	builtin_define ("__mips_eabi");					\
 									\
       if (TARGET_CACHE_BUILTIN)						\
@@ -780,14 +780,14 @@ struct mips_cpu_info {
 /* True if the ABI can only work with 64-bit integer registers.  We
    generally allow ad-hoc variations for TARGET_SINGLE_FLOAT, but
    otherwise floating-point registers must also be 64-bit.  */
-#define ABI_NEEDS_64BIT_REGS	(TARGET_NEWABI || mips_abi == ABI_O64)
+#define ABI_NEEDS_64BIT_REGS	(TARGET_NEWABI || GCC_OPTION (mips_abi) == ABI_O64)
 
 /* Likewise for 32-bit regs.  */
-#define ABI_NEEDS_32BIT_REGS	(mips_abi == ABI_32)
+#define ABI_NEEDS_32BIT_REGS	(GCC_OPTION (mips_abi) == ABI_32)
 
 /* True if the file format uses 64-bit symbols.  At present, this is
    only true for n64, which uses 64-bit ELF.  */
-#define FILE_HAS_64BIT_SYMBOLS	(mips_abi == ABI_64)
+#define FILE_HAS_64BIT_SYMBOLS	(GCC_OPTION (mips_abi) == ABI_64)
 
 /* True if symbols are 64 bits wide.  This is usually determined by
    the ABI's file format, but it can be overridden by -msym32.  Note that
@@ -795,7 +795,7 @@ struct mips_cpu_info {
    although it doesn't change the ABI of a fully-linked object.  */
 #define ABI_HAS_64BIT_SYMBOLS	(FILE_HAS_64BIT_SYMBOLS \
 				 && Pmode == DImode	\
-				 && !TARGET_SYM32)
+				 && !GCC_OPTION (TARGET_SYM32))
 
 /* ISA has instructions for managing 64-bit fp and gp regs (e.g. mips3).  */
 #define ISA_HAS_64BIT_REGS	(ISA_MIPS3				\
@@ -815,7 +815,7 @@ struct mips_cpu_info {
 				  || TARGET_MIPS5900			\
 				  || TARGET_MIPS7000			\
 				  || TARGET_MIPS9000			\
-				  || TARGET_MAD				\
+				  || GCC_OPTION (TARGET_MAD)				\
 				  || ISA_MIPS32				\
 				  || ISA_MIPS32R2			\
 				  || ISA_MIPS64				\
@@ -1042,10 +1042,10 @@ struct mips_cpu_info {
 				 && TARGET_64BIT)
 
 /* The DSP ASE is available.  */
-#define ISA_HAS_DSP		(TARGET_DSP && !TARGET_MIPS16)
+#define ISA_HAS_DSP		(GCC_OPTION (TARGET_DSP) && !TARGET_MIPS16)
 
 /* Revision 2 of the DSP ASE is available.  */
-#define ISA_HAS_DSPR2		(TARGET_DSPR2 && !TARGET_MIPS16)
+#define ISA_HAS_DSPR2		(GCC_OPTION (TARGET_DSPR2) && !TARGET_MIPS16)
 
 /* True if the result of a load is not available to the next instruction.
    A nop will then be needed between instructions like "lw $4,..."
@@ -1653,7 +1653,7 @@ struct mips_cpu_info {
 #define FP_REG_FIRST 32
 #define FP_REG_LAST  63
 #define FP_REG_NUM   (FP_REG_LAST - FP_REG_FIRST + 1)
-#define FP_DBX_FIRST ((write_symbols == DBX_DEBUG) ? 38 : 32)
+#define FP_DBX_FIRST ((GCC_OPTION (write_symbols) == DBX_DEBUG) ? 38 : 32)
 
 #define MD_REG_FIRST 64
 #define MD_REG_LAST  65
@@ -2108,7 +2108,7 @@ enum reg_class
 
 #define STACK_GROWS_DOWNWARD
 
-#define FRAME_GROWS_DOWNWARD flag_stack_protect
+#define FRAME_GROWS_DOWNWARD GCC_OPTION (flag_stack_protect)
 
 /* Size of the area allocated in the frame to save the GP.  */
 
@@ -2296,7 +2296,7 @@ typedef struct mips_args {
    registers.  Under these conditions, we need a more complex form
    of va_list, which tracks GPR, FPR and stack arguments separately.  */
 #define EABI_FLOAT_VARARGS_P \
-	(mips_abi == ABI_EABI && UNITS_PER_FPVALUE >= UNITS_PER_DOUBLE)
+	(GCC_OPTION (mips_abi) == ABI_EABI && UNITS_PER_FPVALUE >= UNITS_PER_DOUBLE)
 
 
 #define EPILOGUE_USES(REGNO)	mips_epilogue_uses (REGNO)
@@ -2354,7 +2354,7 @@ typedef struct mips_args {
 #define MIPS_ICACHE_SYNC(ADDR, SIZE)					\
   /* Flush both caches.  We need to flush the data cache in case	\
      the system has a write-back cache.  */				\
-  emit_library_call (gen_rtx_SYMBOL_REF (Pmode, mips_cache_flush_func),	\
+  emit_library_call (gen_rtx_SYMBOL_REF (Pmode, GCC_OPTION (mips_cache_flush_func)),	\
 		     LCT_NORMAL, VOIDmode, 3, ADDR, Pmode, SIZE, Pmode,	\
 		     GEN_INT (3), TYPE_MODE (integer_type_node))
 
@@ -2470,7 +2470,7 @@ typedef struct mips_args {
 /* A C expression for the cost of a branch instruction.  A value of
    1 is the default; other values are interpreted relative to that.  */
 
-#define BRANCH_COST(speed_p, predictable_p) mips_branch_cost
+#define BRANCH_COST(speed_p, predictable_p) GCC_OPTION (mips_branch_cost)
 #define LOGICAL_OP_NON_SHORT_CIRCUIT 0
 
 /* The MIPS port has several functions that return an instruction count.
@@ -2523,10 +2523,10 @@ typedef struct mips_args {
    ? (mips_get_pic_call_symbol (OPERANDS, SIZE_OPNO)		\
       ? ("%*.reloc\t1f,R_MIPS_JALR,%" #SIZE_OPNO "\n"		\
 	 "1:\t" INSN "r\t%" #TARGET_OPNO "%/")			\
-      : TARGET_MICROMIPS && !TARGET_INTERLINK_COMPRESSED	\
+      : TARGET_MICROMIPS && !GCC_OPTION (TARGET_INTERLINK_COMPRESSED)	\
       ? "%*" INSN "r%!\t%" #TARGET_OPNO "%/"			\
       : "%*" INSN "r\t%" #TARGET_OPNO "%/")			\
-   : TARGET_MICROMIPS && !TARGET_INTERLINK_COMPRESSED		\
+   : TARGET_MICROMIPS && !GCC_OPTION (TARGET_INTERLINK_COMPRESSED)		\
      ? MIPS_ABSOLUTE_JUMP ("%*" INSN "%!\t%" #TARGET_OPNO "%/")	\
      : MIPS_ABSOLUTE_JUMP ("%*" INSN "\t%" #TARGET_OPNO "%/"))	\
 
diff --git a/gcc/config/mips/netbsd.h b/gcc/config/mips/netbsd.h
index 0313345..f2f8651 100644
--- a/gcc/config/mips/netbsd.h
+++ b/gcc/config/mips/netbsd.h
@@ -32,13 +32,13 @@ along with GCC; see the file COPYING3.  If not see
       if (TARGET_ABICALLS)				\
 	builtin_define ("__ABICALLS__");		\
 							\
-      if (mips_abi == ABI_EABI)				\
+      if (GCC_OPTION (mips_abi) == ABI_EABI)				\
 	builtin_define ("__mips_eabi");			\
-      else if (mips_abi == ABI_N32)			\
+      else if (GCC_OPTION (mips_abi) == ABI_N32)			\
 	builtin_define ("__mips_n32");			\
-      else if (mips_abi == ABI_64)			\
+      else if (GCC_OPTION (mips_abi) == ABI_64)			\
 	builtin_define ("__mips_n64");			\
-      else if (mips_abi == ABI_O64)			\
+      else if (GCC_OPTION (mips_abi) == ABI_O64)			\
 	builtin_define ("__mips_o64");			\
     }							\
   while (0)
diff --git a/gcc/config/mips/sdemtk.h b/gcc/config/mips/sdemtk.h
index 15dbf16..8d9f5d1 100644
--- a/gcc/config/mips/sdemtk.h
+++ b/gcc/config/mips/sdemtk.h
@@ -33,7 +33,7 @@ along with GCC; see the file COPYING3.  If not see
       if (TARGET_FLOAT64)				\
 	builtin_define ("__mipsfp64");			\
 							\
-      if (TARGET_NO_FLOAT) 				\
+      if (GCC_OPTION (TARGET_NO_FLOAT)) 				\
 	builtin_define ("__NO_FLOAT");			\
       else if (TARGET_SOFT_FLOAT_ABI)			\
 	builtin_define ("__SOFT_FLOAT");		\
@@ -69,7 +69,7 @@ extern void mips_sync_icache (void *beg, unsigned long len);
    noting that the SDE library takes arguments (address, size).  */
 #undef MIPS_ICACHE_SYNC
 #define MIPS_ICACHE_SYNC(ADDR, SIZE)					\
-  emit_library_call (gen_rtx_SYMBOL_REF (Pmode, mips_cache_flush_func),	\
+  emit_library_call (gen_rtx_SYMBOL_REF (Pmode, GCC_OPTION (mips_cache_flush_func)),	\
 		     LCT_NORMAL, VOIDmode, 2, ADDR, Pmode,		\
 		     SIZE, TYPE_MODE (sizetype))
 
diff --git a/gcc/config/mmix/mmix.c b/gcc/config/mmix/mmix.c
index 2616dd5..9d33003 100644
--- a/gcc/config/mmix/mmix.c
+++ b/gcc/config/mmix/mmix.c
@@ -67,7 +67,7 @@ along with GCC; see the file COPYING3.  If not see
    information.  FIXME: Some tweak to leaf_function_p might be
    preferable.  */
 #define MMIX_CFUN_NEEDS_SAVED_EH_RETURN_ADDRESS			\
- (flag_exceptions						\
+ (GCC_OPTION (flag_exceptions)						\
   && ((reload_completed && df_regs_ever_live_p (MMIX_rJ_REGNUM))	\
       || !leaf_function_p ()))
 
@@ -293,10 +293,10 @@ mmix_option_override (void)
      PIC; we use absolute address items for mmixal compatibility.  FIXME:
      They could be relative if we just elide them to after all pertinent
      labels.  */
-  if (flag_pic)
+  if (GCC_OPTION (flag_pic))
     {
-      warning (0, "-f%s not supported: ignored", (flag_pic > 1) ? "PIC" : "pic");
-      flag_pic = 0;
+      warning (0, "-f%s not supported: ignored", (GCC_OPTION (flag_pic) > 1) ? "PIC" : "pic");
+      GCC_OPTION (flag_pic) = 0;
     }
 }
 
diff --git a/gcc/config/mn10300/mn10300.c b/gcc/config/mn10300/mn10300.c
index eb00077..ed787ce 100644
--- a/gcc/config/mn10300/mn10300.c
+++ b/gcc/config/mn10300/mn10300.c
@@ -72,30 +72,30 @@ static void
 mn10300_option_override (void)
 {
   if (TARGET_AM33)
-    target_flags &= ~MASK_MULT_BUG;
+    GCC_OPTION (target_flags) &= ~MASK_MULT_BUG;
   else
     {
       /* Disable scheduling for the MN10300 as we do
 	 not have timing information available for it.  */
-      flag_schedule_insns = 0;
-      flag_schedule_insns_after_reload = 0;
+      GCC_OPTION (flag_schedule_insns) = 0;
+      GCC_OPTION (flag_schedule_insns_after_reload) = 0;
 
       /* Force enable splitting of wide types, as otherwise it is trivial
 	 to run out of registers.  Indeed, this works so well that register
 	 allocation problems are now more common *without* optimization,
 	 when this flag is not enabled by default.  */
-      flag_split_wide_types = 1;
+      GCC_OPTION (flag_split_wide_types) = 1;
     }
 
-  if (mn10300_tune_string)
+  if (GCC_OPTION (mn10300_tune_string))
     {
-      if (strcasecmp (mn10300_tune_string, "mn10300") == 0)
+      if (strcasecmp (GCC_OPTION (mn10300_tune_string), "mn10300") == 0)
 	mn10300_tune_cpu = PROCESSOR_MN10300;
-      else if (strcasecmp (mn10300_tune_string, "am33") == 0)
+      else if (strcasecmp (GCC_OPTION (mn10300_tune_string), "am33") == 0)
 	mn10300_tune_cpu = PROCESSOR_AM33;
-      else if (strcasecmp (mn10300_tune_string, "am33-2") == 0)
+      else if (strcasecmp (GCC_OPTION (mn10300_tune_string), "am33-2") == 0)
 	mn10300_tune_cpu = PROCESSOR_AM33_2;
-      else if (strcasecmp (mn10300_tune_string, "am34") == 0)
+      else if (strcasecmp (GCC_OPTION (mn10300_tune_string), "am34") == 0)
 	mn10300_tune_cpu = PROCESSOR_AM34;
       else
 	error ("-mtune= expects mn10300, am33, am33-2, or am34");
@@ -600,7 +600,7 @@ mn10300_can_use_retf_insn (void)
 {
   /* Don't bother if we're not optimizing.  In this case we won't
      have proper access to df_regs_ever_live_p.  */
-  if (!optimize)
+  if (!GCC_OPTION (optimize))
     return false;
 
   /* EH returns alter the saved return address; MDR is not current.  */
@@ -764,7 +764,7 @@ mn10300_expand_prologue (void)
   /* If we use any of the callee-saved registers, save them now.  */
   mn10300_gen_multiple_store (mask);
 
-  if (flag_stack_usage_info)
+  if (GCC_OPTION (flag_stack_usage_info))
     current_function_static_stack_size = size + popcount (mask) * 4;
 
   if (TARGET_AM33_2 && fp_regs_to_save ())
@@ -782,7 +782,7 @@ mn10300_expand_prologue (void)
       unsigned int strategy_size = (unsigned)-1, this_strategy_size;
       rtx reg;
 
-      if (flag_stack_usage_info)
+      if (GCC_OPTION (flag_stack_usage_info))
 	current_function_static_stack_size += num_regs_to_save * 4;
 
       /* We have several different strategies to save FP registers.
@@ -1017,7 +1017,7 @@ mn10300_expand_prologue (void)
 			      stack_pointer_rtx,
 			      GEN_INT (-size))));
 
-  if (flag_pic && df_regs_ever_live_p (PIC_OFFSET_TABLE_REGNUM))
+  if (GCC_OPTION (flag_pic) && df_regs_ever_live_p (PIC_OFFSET_TABLE_REGNUM))
     emit_insn (gen_load_pic ());
 }
 
@@ -1820,7 +1820,7 @@ static rtx
 mn10300_legitimize_address (rtx x, rtx oldx ATTRIBUTE_UNUSED,
 			    enum machine_mode mode ATTRIBUTE_UNUSED)
 {
-  if (flag_pic && ! mn10300_legitimate_pic_operand_p (x))
+  if (GCC_OPTION (flag_pic) && ! mn10300_legitimate_pic_operand_p (x))
     x = mn10300_legitimize_pic_address (oldx, NULL_RTX);
 
   /* Uh-oh.  We might have an address for x[n-100000].  This needs
@@ -1954,7 +1954,7 @@ mn10300_legitimate_address_p (enum machine_mode mode, rtx x, bool strict)
   rtx base, index;
 
   if (CONSTANT_ADDRESS_P (x))
-    return !flag_pic || mn10300_legitimate_pic_operand_p (x);
+    return !GCC_OPTION (flag_pic) || mn10300_legitimate_pic_operand_p (x);
 
   if (RTX_OK_FOR_BASE_P (x, strict))
     return true;
@@ -1994,7 +1994,7 @@ mn10300_legitimate_address_p (enum machine_mode mode, rtx x, bool strict)
     return IN_RANGE (INTVAL (index), -1 - 0x7fffffff, 0x7fffffff);
 
   if (CONSTANT_ADDRESS_P (index))
-    return !flag_pic || mn10300_legitimate_pic_operand_p (index);
+    return !GCC_OPTION (flag_pic) || mn10300_legitimate_pic_operand_p (index);
 
   return false;
 }
@@ -2264,7 +2264,7 @@ mn10300_register_move_cost (enum machine_mode mode ATTRIBUTE_UNUSED,
 
   /* From here on, all we need consider are legal combinations.  */
 
-  if (optimize_size)
+  if (GCC_OPTION (optimize_size))
     {
       /* The scale here is bytes * 2.  */
 
@@ -2513,7 +2513,7 @@ mn10300_encode_section_info (tree decl, rtx rtl, int first)
   if (GET_CODE (symbol) != SYMBOL_REF)
     return;
 
-  if (flag_pic)
+  if (GCC_OPTION (flag_pic))
     SYMBOL_REF_FLAG (symbol) = (*targetm.binds_local_p) (decl);
 }
 
@@ -2852,7 +2852,7 @@ mn10300_conditional_register_usage (void)
 	   i <= LAST_FP_REGNUM; i++)
 	fixed_regs[i] = call_used_regs[i] = 1;
     }
-  if (flag_pic)
+  if (GCC_OPTION (flag_pic))
     fixed_regs[PIC_OFFSET_TABLE_REGNUM] =
     call_used_regs[PIC_OFFSET_TABLE_REGNUM] = 1;
 }
@@ -3316,7 +3316,7 @@ static void
 mn10300_reorg (void)
 {
   /* These are optimizations, so only run them if optimizing.  */
-  if (TARGET_AM33 && (optimize > 0 || optimize_size))
+  if (TARGET_AM33 && (GCC_OPTION (optimize) > 0 || GCC_OPTION (optimize_size)))
     {
       if (TARGET_ALLOW_SETLB)
 	mn10300_scan_for_setlb_lcc ();
diff --git a/gcc/config/mn10300/mn10300.h b/gcc/config/mn10300/mn10300.h
index 1d91104..e98f89b 100644
--- a/gcc/config/mn10300/mn10300.h
+++ b/gcc/config/mn10300/mn10300.h
@@ -64,9 +64,9 @@
 
 extern enum processor_type mn10300_tune_cpu;
 
-#define TARGET_AM33	(mn10300_processor >= PROCESSOR_AM33)
-#define TARGET_AM33_2	(mn10300_processor >= PROCESSOR_AM33_2)
-#define TARGET_AM34	(mn10300_processor >= PROCESSOR_AM34)
+#define TARGET_AM33	(GCC_OPTION (mn10300_processor) >= PROCESSOR_AM33)
+#define TARGET_AM33_2	(GCC_OPTION (mn10300_processor) >= PROCESSOR_AM33_2)
+#define TARGET_AM34	(GCC_OPTION (mn10300_processor) >= PROCESSOR_AM34)
 
 #ifndef PROCESSOR_DEFAULT
 #define PROCESSOR_DEFAULT PROCESSOR_MN10300
diff --git a/gcc/config/moxie/moxie.c b/gcc/config/moxie/moxie.c
index b646a43..f7eb9dc 100644
--- a/gcc/config/moxie/moxie.c
+++ b/gcc/config/moxie/moxie.c
@@ -284,7 +284,7 @@ moxie_expand_prologue (void)
 
   moxie_compute_frame ();
 
-  if (flag_stack_usage_info)
+  if (GCC_OPTION (flag_stack_usage_info))
     current_function_static_stack_size = cfun->machine->size_for_adjusting_sp;
 
   /* Save callee-saved registers.  */
